/// @file   Glyphs.hpp
/// @author Armin Co
///

#ifndef GUI_CORE_GLYPHS_HPP
#define GUI_CORE_GLYPHS_HPP

#include <map>
#include <glm/glm.hpp>


#include "Shader.hpp"

namespace GuiCore
{
struct Character {
    unsigned int textureId;  // ID handle of the glyph texture
    glm::ivec2   size;       // Size of glyph
    glm::ivec2   bearing;    // Offset from baseline to left/top of glyph
    unsigned int advance;    // Offset to advance to next glyph
};

class Glyphs
{
public: 
    static void setup();
    static void renderText(std::string text, float x, float y, float scale, glm::vec3 color);

private:
    static std::map<char, Character> s_characters;
    static Shader *m_shader;
    static GLuint m_vertexArray;
    static GLuint m_vertexBuffer;
    static glm::mat4 projection;
};

}

#endif