/// @file   ImGuiLayer.hpp
/// @author Armin Co
///

#ifndef IM_GUI_LAYER_HPP
#define IM_GUI_LAYER_HPP

#include "Layer.hpp"
#include "Event.hpp"

namespace GuiCore
{

    class ImGuiLayer : public Layer
    {
    public:
        ImGuiLayer();
        virtual ~ImGuiLayer();

        virtual void onAttach() override;
        virtual void onDetach() override;

        void begin();
        void end();

        virtual void onEvent(Event &event);
        bool onMouseButtonPressed(Event &event);

    private:
        float m_time = 0.0f;
    };

}

#endif