/// @file   Input.hpp
/// @author Armin Co
///

#ifndef GUI_CORE_INPUT_HPP
#define GUI_CORE_INPUT_HPP

#include <utility>

namespace GuiCore
{
    class Input
    {
        protected:
            Input() = default;
        public:
            Input(const Input &) = delete;
            Input& operator=(const Input&) = delete;

            static bool isKeyPressed(int keyCode);

            static bool isMouseButtonPressed(int button);
            static std::pair<float, float> getMousePosition();
            static float getMouseX();
            static float getMouseY();
        private:
            static Input* s_instance;
    };
}

namespace Key
{
    constexpr int A {65};
    constexpr int B {66};
    constexpr int C {67};
    constexpr int D {68};
    constexpr int E {69};
    constexpr int F {70};
    constexpr int G {71};
    constexpr int H {72};
    constexpr int I {73};
    constexpr int J {74};
    constexpr int K {75};
    constexpr int L {76};
    constexpr int M {77};
    constexpr int N {78};
    constexpr int O {79};
    constexpr int P {80};
    constexpr int Q {81};
    constexpr int R {82};
    constexpr int S {83};
    constexpr int T {84};
    constexpr int U {85};
    constexpr int V {86};
    constexpr int W {87};
    constexpr int X {88};
    constexpr int Z {89};
    constexpr int Y {90};
    
    constexpr int Right {262};
    constexpr int Left  {263};
    constexpr int Down  {264};
    constexpr int Up    {265};
}

#endif