/// @file   Layer.hpp
/// @author Armin Co
///

#ifndef GUI_CORE_LAYER_HPP
#define GUI_CORE_LAYER_HPP

#include <string>

#include "Event.hpp"
#include "Timestep.hpp"

namespace GuiCore
{
    class Layer
    {
    public:
        Layer(const std::string &name = "Layer");
        virtual ~Layer();

        virtual void onAttach() {}
        virtual void onDetach() {}
        virtual void onUpdate(Timestep ts) {}
        virtual void onGuiRender() {}
        virtual void onEvent(Event &event){}

        const std::string &getName() const;

    protected:
        std::string m_debugName;
    };

}

#endif