/// @file   Log.cpp
/// @author Armin Co
///

#include "spdlog/sinks/stdout_color_sinks.h"

#include "Log.hpp"

namespace GuiCore
{
    std::shared_ptr<spdlog::logger> Log::s_logger;

    void Log::setup()
    {
        spdlog::set_pattern("%^[%T] %n: %v%$");
        s_logger = spdlog::stdout_color_mt("GuiCore");
        s_logger->set_level(spdlog::level::trace);
    }

    std::shared_ptr<spdlog::logger> Log::get()
    {
        return s_logger;
    }
}
