/// @file   Shader.hpp
/// @author Armin Co
///

#ifndef OPEN_GL_SHADER_HPP
#define OPEN_GL_SHADER_HPP

#include <string>
#include <GL/gl3w.h>
#include <GLFW/glfw3.h>
namespace GuiCore
{
    class Shader
    {
    public:
        ~Shader();

        GLuint getRendererID();
        static Shader* fromGLSLTextFiles(const std::string& vertexShaderPath, const std::string &fragmentShaderPath);
    private:
        Shader() = default;
        void loadFromGLSLTextFiles(const std::string &vertexShaderPath, const std::string &fragmentShaderPath);
        GLuint compileShader(GLenum type, const std::string &source);
    private:
        GLuint m_rendererID;
    };
}

#endif