/// @file   QPongApp.cpp
/// @author Armin Co
///

#include <memory>

#include <GuiCore/Application.hpp>

#include "MainMenuLayer.hpp"
#include "GameLayer.hpp"
#include "PlayingLayer.hpp"
#include "Log.hpp"
class App : public GuiCore::Application
{
public:
    App()
        : Application("QPong Application")
    {
        QPong::Log::setup();
        pushLayer(std::make_shared<QPong::MainMenuLayer>());
    }
};

int main()
{
    std::unique_ptr<App> app = std::make_unique<App>();
    
    QPong::Log::get()->info("Starting App!");
    
    app->run();
    return 0;
}