#version 450 core
layout (location = 0) in vec3 v_position;
layout (location = 1) in vec2 v_particle_complex;
layout (location = 2) in float potential;
uniform mat4 u_viewProjection;
uniform int u_showPotential;
out vec3 fragmentColor;
void main()
{
    float pot = potential * 120.0;
    if (u_showPotential==0)
    {
        pot = 0.0;
    }

    gl_Position = u_viewProjection * vec4(v_position, 1.0f);
    float real = v_particle_complex[0];
    float imag = v_particle_complex[1];
    float real2 = real * real;
    float imag2 = imag * imag;
    fragmentColor = vec3(
                        sqrt(real2) * 5.0 + pot,
                        sqrt(real2) * 5.0 + sqrt(imag2) * 5.0 + pot / 2.0,
                        sqrt(imag2) * 5.0);
}